VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Class1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Rem LibraryClass
Rem Microsoft XML,v30
Const XMLFileName = "D:\Work-Folder\VB\XML\Lesson 02 F033.xml"
Private Library As New DOMDocument30
Private IsOk As Boolean
Public Sub Class_Initialize()
  Library.async = False
  IsOk = Library.Load(XMLFileName)
  If Not IsOk Then
    'MsgBox "Lesson 02 F034.xml not opened", vbCritical
    IsOk = IsDataValid()
  End If
End Sub

Public Function GetStateFlag() As Boolean
  GetStateFlag = IsOk
End Function

Public Function IsDataValid() As Boolean
  Dim ErrObj As IXMLDOMParseError
  Dim IsValid As Boolean
  Dim Msg As String
  Set ErrObj = Library.parseError
  IsValid = (ErrObj.reason = "")
  If Not IsValid Then
    With ErrObj
      Msg = .reason & " LinePos " & .linepos & " In LineNo " & .Line
    End With
    MsgBox Msg, vbCritical
  End If
  IsDataValid = IsValid
End Function

Public Sub MakeRealBookNumber()
  Dim NodeList As IXMLDOMNodeList
  Dim Node As IXMLDOMNode
  Set NodeList = Library.selectNodes("Library")
  Set Node = NodeList.Item(0)
  Set NodeList = Node.selectNodes("Folder")
  Set Node = NodeList.Item(0)
  MsgBox Node.nodeName
  MsgBox Node.Attributes(0).nodeValue
  MsgBox "  - " & GetRealBookNumber(Node)
End Sub

Private Function GetRealBookNumber(ByVal UpperNode As IXMLDOMNode) As Long
  Dim NodeList As IXMLDOMNodeList, Node As IXMLDOMNode
  Dim Number As Long, I As Integer
  Number = 0
  Set NodeList = UpperNode.selectNodes("Folder")
  For I = 0 To NodeList.length - 1
    Set Node = NodeList.Item(I)
    'MsgBox Node.nodeName
    MsgBox Node.Attributes(0).nodeValue
    Number = Number + GetRealBookNumber(Node)
  Next I
  Set NodeList = UpperNode.selectNodes("Item")
  Number = Number + NodeList.length
  GetRealBookNumber = Number
End Function
